<?php

namespace Brickscore;

//Load elements
add_action( 'init', function() {
  $element_options = [
    'bc_counter' => 'bc_counter_enable',
    'bc_twist_title' => 'bc_twist_title_enable',
    'bc_circular_title' => 'bc_circular_title_enable',
    'bc_letter_launcher' => 'bc_letter_launcher_enable',
    'bc_blade_title' => 'bc_blade_title_enable',
    'bc_swap_title' => 'bc_swap_title_enable',
    'bc_highlight_title' => 'bc_highlight_title_enable',
    'bc_underline_title' => 'bc_underline_title_enable',
    'bc_svg_title' => 'bc_svg_title_enable',
    'bc_title_images' => 'bc_title_images_enable',
    'bc_scroll_reading' => 'bc_scroll_reading_enable',
    'bc_random_letters' => 'bc_random_letters_enable',
    'bc_scribble_title' => 'bc_scribble_title_enable',
    'bc_scribble_child' => 'bc_scribble_title_enable',
    'bc_3d_swap_title' => 'bc_3d_swap_title_enable',
    'bc_blended_title' => 'bc_blended_title_enable',
    'bc_decode_hover' => 'bc_decode_hover_enable',
    'bc_decode_reveal' => 'bc_decode_reveal_enable',
    'bc_unfold_reveal' => 'bc_unfold_reveal_enable',
    'bc_mask_hover' => 'bc_mask_hover_enable',
    'bc_exchange_title' => 'bc_exchange_title_enable',

    'bc_anyside_button' => 'bc_anyside_button_enable',
    'bc_arrow_button' => 'bc_arrow_button_enable',
    'bc_crystal_button' => 'bc_crystal_button_enable',
    'bc_layer_button' => 'bc_layer_button_enable',
    'bc_ripple_button' => 'bc_ripple_button_enable',
    'bc_marquee_button' => 'bc_marquee_button_enable',
    'bc_microbox_button' => 'bc_microbox_button_enable',
    'bc_glowing_button' => 'bc_glowing_button_enable',
    'bc_mask_button' => 'bc_mask_button_enable',
    'bc_prism_button' => 'bc_prism_button_enable',
    'bc_neumorphic_button' => 'bc_neumorphic_button_enable',

    'bc_core_burguer' => 'bc_core_burguer_enable',
    'bc_stripe_megamenu' => 'bc_stripe_megamenu_enable',
    'bc_stripe_mm_contentlist' => 'bc_stripe_megamenu_enable',
    'bc_stripe_mm_item' => 'bc_stripe_megamenu_enable',
    'bc_sticky_nav' => 'bc_sticky_nav_enable',
    'bc_offcanvas_menu' => 'bc_offcanvas_menu_enable',
    'bc_overlay_menu' => 'bc_overlay_menu_enable',
    'bc_morphing_menu' => 'bc_morphing_menu_enable',
    'bc_morphing_menu_item' => 'bc_morphing_menu_enable',
    'bc_expanding_menu' => 'bc_expanding_menu_enable',
    'bc_simple_menu' => 'bc_simple_menu_enable',
    'bc_multioffcanvas' => 'bc_multioffcanvas_enable',
    'bc_suboffcanvas' => 'bc_multioffcanvas_enable',
    
    'bc_scrollbar' => 'bc_scrollbar_enable',
    'bc_cursor' => 'bc_cursor_enable',
    'bc_marquee' => 'bc_marquee_enable',
    'bc_particles' => 'bc_particles_enable',
    'bc_grained' => 'bc_grained_enable',
    'bc_smooth_scroll' => 'bc_smooth_scroll_enable',
    'bc_back_to_top' => 'bc_back_to_top_enable',
    'bc_sharer' => 'bc_sharer_enable',
    'bc_tippy' => 'bc_tippy_enable',
    'bc_glitchy' => 'bc_glitchy_enable',
    'bc_parallax' => 'bc_parallax_enable',
    'bc_dark_mode' => 'bc_dark_mode_enable',
    'bc_image_reveal' => 'bc_image_reveal_enable',
    'bc_lottie' => 'bc_lottie_enable',
    'bc_zoom_lens' => 'bc_zoom_lens_enable',
    'bc_expander' => 'bc_expander_enable',
    'bc_core_slider' => 'bc_core_slider_enable',
    'bc_clickandcopy' => 'bc_clickandcopy_enable',
    'bc_beforeafter_image' => 'bc_beforeafter_image_enable',
    'bc_3dhover' => 'bc_3dhover_enable',
    'bc_3dhover_child' => 'bc_3dhover_enable',
    'bc_video_sequence' => 'bc_video_sequence_enable',
    'bc_generatorism' => 'bc_generatorism_enable',
    'bc_image_hotspots' => 'bc_image_hotspots_enable',
    'bc_image_hotspot' => 'bc_image_hotspots_enable',
    'bc_core_tabs' => 'bc_core_tabs_enable',
    'bc_spotlight' => 'bc_spotlight_enable',
    'bc_divider' => 'bc_divider_enable',
    'bc_flipbox' => 'bc_flipbox_enable',
    'bc_bubbles' => 'bc_bubbles_enable',
    'bc_bubbles_wrapper' => 'bc_bubbles_enable',
    'bc_bubble' => 'bc_bubbles_enable',
    'bc_observer' => 'bc_observer_enable',
    'bc_drawer' => 'bc_drawer_enable',
    'bc_codepen' => 'bc_codepen_enable',
  ];

  $features_options = [
    'bc_core_animator' => 'bc_core_animator_enable',
  ];

  foreach ($element_options as $element_name => $option_name) { //Save elements choices by user
    $option_value = get_option($option_name, 'true');
    if ($option_value === 'true') {
      $element_files[] = __DIR__ . '/elements/' . $element_name . '.php';
    }
  }

  foreach ($features_options as $feature_name => $option_name) { //Save features choices by user
    $option_value = get_option($option_name, 'true');
    if ($option_value === 'true') {
      $feature_files[] = __DIR__ . '/features/' . $feature_name . '.php';
    }
  }

  update_option('brickscore_element_version', BRICKSCORE_VERSION); //Cache version
  wp_enqueue_style( 'brickscore_stylesheet', plugin_dir_url( __FILE__ ) . 'elements/css/brickscore.min.css', array(), get_option('brickscore_element_version'), false ); //Global CSS

  if(!empty($element_files)){
    foreach ( $element_files as $file ) { // Load Elements
      \Bricks\Elements::register_element( $file );
    }
  }
  
  if(!empty($feature_files)){
    foreach ( $feature_files as $file ) { // Load Features
      require_once __DIR__ . '/features/' . $feature_name . '.php';
      (new BC_Animator())->init();
    }
  }
}, 11 );

add_filter( 'bricks/builder/i18n', function( $i18n ) { //Translations
  $i18n['custom'] = esc_html__( 'Custom', 'bricks' );

  return $i18n;
} );

// Assets Loading
add_action( 'wp_enqueue_scripts', function() {
  $cdn_options = [
    plugin_dir_url( __FILE__ ) . 'local_assets/bc_gsap.min.js' => 'bc_gsap_enable',
    plugin_dir_url( __FILE__ ) . 'local_assets/bc_scrolltrigger.min.js' => 'bc_scrolltrigger_enable',
    plugin_dir_url( __FILE__ ) . 'local_assets/bc_splittext.min.js' => 'bc_splittext_enable',
  ];

  foreach ($cdn_options as $cdn_name => $option_name) {
    $option_value = get_option($option_name, 'true');

    if ($option_value === 'true') {
      wp_enqueue_script($option_name, $cdn_name, array(), get_option('brickscore_element_version'), true);
    }
  }
}, 11 );