<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class B_Anysidebutton extends \Bricks\Element {
  public $category     = 'Brickscore - Buttons';
  public $name         = 'anysidebutton';
  public $icon         = 'fa-solid fa-square-minus';
  public $scripts      = ['anysidebutton'];

  public function get_label() {
    return esc_html__( 'Anyside Button', 'bricks' );
  }

  public function set_control_groups() {

  }

  public function set_controls() {
    $this->controls['inner_title'] = [
        'tab'            => 'content',
        'type'           => 'text',
        'hasDynamicData' => 'text',
        'default'        => esc_html__( 'Anyside Button', 'bricks' ),
        'placeholder'    => esc_html__( 'Title goes here ..', 'bricks' ),
    ];
    $this->controls['link'] = [
        'tab'   => 'content',
        'label' => esc_html__( 'Link to', 'bricks' ),
        'type'  => 'link',
    ];
    $this->controls['whitespace'] = [
      'tab'         => 'content',
      'label'       => esc_html__( 'White space', 'bricks' ),
      'type'        => 'select',
      'options'     => [
          'wrap' => 'wrap',
          'nowrap' => 'nowrap',
      ],
      'inline'      => true,
      'css'     => [
          [
            'property' => 'white-space',
            'selector' => '',
          ],
        ],
      'placeholder'        => 'wrap',
  ];
    $this->controls['padding'] = [
      'tab'         => 'content',
      'label'       => esc_html__( 'Padding', 'bricks' ),
      'type'        => 'dimensions',
      'css'     => [
          [
            'property' => 'padding',
            'selector' => '',
          ],
        ],
        'placeholder' => [
          'top' => 40,
          'right' => 40,
          'bottom' => 40,
          'left' => 40,
        ],
  ];
    $this->controls['background'] = [
        'tab'         => 'content',
        'label'       => esc_html__( 'Background', 'bricks' ),
        'type'        => 'background',
        'inline'      => true,
        'css'     => [
            [
              'property' => 'background',
              'selector' => '',
            ],
          ],
    ];
    $this->controls['color'] = [
        'tab'         => 'content',
        'label'       => esc_html__( 'Typography', 'bricks' ),
        'type'        => 'typography',
        'inline'      => true,
        'css'     => [
            [
              'property' => 'typography',
              'selector' => '',
            ],
          ],
    ];
    $this->controls['border'] = [
        'tab'         => 'content',
        'label'       => esc_html__( 'Border', 'bricks' ),
        'type'        => 'border',
        'inline'      => true,
        'css'     => [
            [
              'property' => 'border',
              'selector' => '',
            ],
          ],
    ];

    $this->controls['animationSeparator'] = [
      'label'      => esc_html__( 'Animation', 'bricks' ),
      'type'       => 'separator',
    ];
    $this->controls['anysidetype'] = [
      'tab' => 'content',
      'label' => esc_html__( 'Event', 'bricks' ),
      'type'        => 'select',
      'options'     => [
        'hover' => 'hover',
        'click' => 'click',
      ],
      'inline' => true,
      'placeholder' => 'hover',
      'default' => 'hover',
    ];
    $this->controls['transitionseasing'] = [
      'tab'         => 'content',
      'label'       => esc_html__( 'Transitions CSS easing', 'bricks' ),
      'type'        => 'text',
      'inline'      => true,
      'hasDynamicData' => false,
      'css'     => [
          [
            'property' => '--easing',
            'selector' => '',
          ],
      ],
      'placeholder'  => 'ease',
      'required' => [ 'anysidetype', '!=', 'click'],
    ];
    $this->controls['circledimensions'] = [
      'tab'         => 'content',
      'label'       => esc_html__( 'Circle dimensions', 'bricks' ),
      'type'        => 'number',
      'units'      => true,
      'inline'      => true,
      'css'     => [
          [
            'property' => '--click-dimensions',
            'selector' => '',
          ],
      ],
      'placeholder'  => '500px',
      'required' => [ 'anysidetype', '=', 'click'],
    ];
    $this->controls['hoverbackground'] = [
        'tab'         => 'content',
        'label'       => esc_html__( 'Path background', 'bricks' ),
        'type'        => 'background',
        'inline'      => true,
        'css'     => [
            [
              'property' => 'background',
              'selector' => '.bc-anyside-button__anyside-div, .bc-anyside-button__anyside-span',
            ],
          ],
    ];
    $this->controls['pathtransitionida'] = [ /*define el duration en click*/
      'tab'         => 'content',
      'label'       => esc_html__( 'In path transition', 'bricks' ),
      'type'        => 'number',
      'unit'      => 'ms',
      'inline'      => true,
      'css'     => [
          [
            'property' => '--pathtransition-ida',
            'selector' => '',
          ],
      ],
      'placeholder'        => '800ms',
      'required' => [ 'anysidetype', '!=', 'click'],
    ];
    $this->controls['pathtransition'] = [ /*define el duration en click*/
        'tab'         => 'content',
        'label'       => esc_html__( 'Out path transition', 'bricks' ),
        'type'        => 'number',
        'unit'      => 'ms',
        'inline'      => true,
        'css'     => [
            [
              'property' => '--pathtransition',
              'selector' => '',
            ],
        ],
        'placeholder'        => '800ms',
    ];
    $this->controls['hovercolor'] = [
        'tab'         => 'content',
        'label'       => esc_html__( 'Color', 'bricks' ),
        'type'        => 'color',
        'inline'      => true,
        'css'     => [
            [
              'property' => '--hover-color',
              'selector' => '',
            ],
          ],
        'required' => [ 'anysidetype', '!=', 'click'],
    ];
    $this->controls['colortransitionida'] = [
      'tab'         => 'content',
      'label'       => esc_html__( 'In color transition', 'bricks' ),
      'type'        => 'number',
      'unit'      => 'ms',
      'inline'      => true,
      'css'     => [
          [
            'property' => '--colortransition-ida',
            'selector' => '',
          ],
      ],
      'placeholder'        => '800ms',
      'required' => [ 'anysidetype', '!=', 'click'],
    ];
    $this->controls['colortransition'] = [
      'tab'         => 'content',
      'label'       => esc_html__( 'Out color transition', 'bricks' ),
      'type'        => 'number',
      'unit'      => 'ms',
      'inline'      => true,
      'css'     => [
          [
            'property' => '--colortransition',
            'selector' => '',
          ],
      ],
      'placeholder'        => '800ms',
      'required' => [ 'anysidetype', '!=', 'click'],
    ];
  }


  public function enqueue_scripts() {
    wp_enqueue_script( 'anysidebutton', plugin_dir_url( __FILE__ ) . 'js/bc_anyside_button.min.js', array('bricks-scripts'), get_option('brickscore_element_version'), false);
  }

  public function render() {
    $settings = $this->settings;
    $inner_title    = ! empty( $settings['inner_title'] ) ? $settings['inner_title'] : 'Brickscore';
    $anysidetype    = ! empty( $settings['anysidetype'] ) ? $settings['anysidetype'] : 'hover';
    $anysidedurationclick    = ! empty( $settings['pathtransition'] ) ? $settings['pathtransition'] : 800;

		if ( ! empty( $settings['link'] ) ) {
			$this->set_link_attributes( '_root', $settings['link'] );
		}


    $this->set_attribute( '_root', 'class', 'bc-anyside-button' );
    $this->set_attribute( '_root', 'data-type', $anysidetype );
    $this->set_attribute( '_root', 'data-durationclick', $anysidedurationclick );

    if($anysidetype == 'hover'){
      $output = "
      <a {$this->render_attributes( '_root' )}>
        <span class='bc-anyside-button__title'>$inner_title</span>
        <div class='bc-anyside-button__anyside-div'></div>
      </a>
      ";
    }else if($anysidetype == 'click'){
      $output = "
      <a {$this->render_attributes( '_root' )}>
        <span class='bc-anyside-button__title'>$inner_title</span>
      </a>
      ";
    }

	echo $output;
  }
}