<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class B_Core_Burguer extends \Bricks\Element {
  public $category     = 'Brickscore - Menus';
  public $name         = 'coreburguer';
  public $icon         = 'ti-menu';
  public $scripts      = ['coreburguer'];

  public function get_label() {
    return esc_html__( 'Core Burger', 'bricks' );
  }

  public function set_control_groups() {

  }

  public function set_controls() {
    $this->controls['type'] = [
        'tab'         => 'content',
        'label'       => esc_html__( 'Type', 'bricks' ),
        'type'        => 'select',
        'options'     => [
            //'style1' => 'spread',
            'style5' => 'simple',
            'style2' => 'unify',
            //'style6' => 'fade',
            'style8' => 'fade',
            'style7' => 'rotate',
            'style10' => 'rotatev2',
            'style3' => 'doble collapse',
            'style4' => 'triple collapse',
            'style9' => 'full collapse',
        ],
        'inline'      => true,
        'placeholder' => 'simple',
    ];
    $this->controls['reversed2'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label'    => esc_html__( 'Reverse', 'bricks' ),
        'type'     => 'checkbox',
        'required' => [ 'type', '=', 'style2'],
    ];
    $this->controls['reversed5'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label'    => esc_html__( 'Reverse', 'bricks' ),
        'type'     => 'checkbox',
        'required' => [ 'type', '=', 'style5'],
    ];
    $this->controls['reversed6'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label'    => esc_html__( 'Reverse', 'bricks' ),
        'type'     => 'checkbox',
        'required' => [ 'type', '=', 'style6'],
    ];
    $this->controls['reversed7'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label'    => esc_html__( 'Reverse', 'bricks' ),
        'type'     => 'checkbox',
        'required' => [ 'type', '=', 'style7'],
    ];
    $this->controls['reversed10'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label'    => esc_html__( 'Reverse', 'bricks' ),
        'type'     => 'checkbox',
        'required' => [ 'type', '=', 'style10'],
    ];
    $this->controls['dimensions'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Dimensions', 'bricks' ),
        'type'  => 'number',
        'units' => true,
        'css'     => [
        [
            'property' => '--burguer-dimensions',
            'selector' => '.bc-burguer-style1, .bc-burguer-style2, .bc-burguer-style3, .bc-burguer-style4, .bc-burguer-style5, 
            .bc-burguer-style6, .bc-burguer-style7, .bc-burguer-style8, .bc-burguer-style9, .bc-burguer-style10',
        ],
        ],
        'placeholder' => '50px',
    ];
    $this->controls['strokecolor'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Stroke Color', 'bricks' ),
        'type'  => 'color',
        'css'     => [
        [
            'property' => '--burguer-stroke-color',
            'selector' => '.bc-burguer-style1, .bc-burguer-style2, .bc-burguer-style3, .bc-burguer-style4, .bc-burguer-style5, 
            .bc-burguer-style6, .bc-burguer-style7, .bc-burguer-style8, .bc-burguer-style9, .bc-burguer-style10',
        ],
        ],
    ];
    $this->controls['strokewidth'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Stroke Width', 'bricks' ),
        'type'  => 'number',
        'units' => true,
        'inline' => true,
        'css'     => [
        [
            'property' => '--burguer-stroke-width',
            'selector' => '.bc-burguer-style1, .bc-burguer-style2, .bc-burguer-style3, .bc-burguer-style4, .bc-burguer-style5, 
            .bc-burguer-style6, .bc-burguer-style7, .bc-burguer-style8, .bc-burguer-style9, .bc-burguer-style10',
        ],
        ],
        'placeholder' => '2px',
    ];

    $this->controls['strokerounded'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label'    => esc_html__( 'Sharp', 'bricks' ),
        'type'     => 'checkbox',
        'css'      => [
            [
                'property' => '--burguer-rounded',
                'selector' => '.bc-burguer-style1, .bc-burguer-style2, .bc-burguer-style3, .bc-burguer-style4, .bc-burguer-style5, 
                .bc-burguer-style6, .bc-burguer-style7, .bc-burguer-style8, .bc-burguer-style9, .bc-burguer-style10',
            ],
        ],
    ];

    $this->controls['animationSeparator'] = [
        'label'      => esc_html__( 'Animation', 'bricks' ),
        'type'       => 'separator',
    ];
    $this->controls['duration'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Duration', 'bricks' ),
        'type'  => 'number',
        'unit' => 'ms',
        'css'     => [
        [
            'property' => '--burguer-duration',
            'selector' => '.bc-burguer-style1, .bc-burguer-style2, .bc-burguer-style3, .bc-burguer-style4, .bc-burguer-style5, 
            .bc-burguer-style6, .bc-burguer-style7, .bc-burguer-style8, .bc-burguer-style9, .bc-burguer-style10',
        ],
        ],
        'placeholder' => '600ms',
    ];
    $this->controls['easing'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Easing', 'bricks' ),
        'type'  => 'text',
        'inline' => true,
        'css'     => [
        [
            'property' => '--burguer-easing',
            'selector' => '.bc-burguer-style1, .bc-burguer-style2, .bc-burguer-style3, .bc-burguer-style4, .bc-burguer-style5, 
            .bc-burguer-style6, .bc-burguer-style7, .bc-burguer-style8, .bc-burguer-style9, .bc-burguer-style10',
        ],
        ],
        'placeholder' => 'ease',
    ];

    $this->controls['bodyscrollingSeparator'] = [
        'type'       => 'separator',
    ];
    $this->controls['bodyscrollingnote'] = [
        'tab' => 'content',
        'description' => sprintf(html_entity_decode(esc_html__( 'Lock body scrolling when toggling Core Burguer to prevent body scrolling', 'bricks' )))
    ];
    $this->controls['bodyscrolling'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label'    => esc_html__( 'Lock body scrolling', 'bricks' ),
        'type'     => 'checkbox',
    ];
  }


  public function enqueue_scripts() {
    wp_enqueue_script( 'coreburguer', plugin_dir_url( __FILE__ ) . 'js/bc_core_burguer.min.js', array('bricks-scripts'), get_option('brickscore_element_version'), false);
  }

  public function render() {
    $settings = $this->settings;
    $type    = ! empty( $settings['type'] ) ? $settings['type'] : 'style5';
    $reversed2    = ! empty( $settings['reversed2'] ) ? $settings['reversed2'] : false;
    $reversed5    = ! empty( $settings['reversed5'] ) ? $settings['reversed5'] : false;
    $reversed6    = ! empty( $settings['reversed6'] ) ? $settings['reversed6'] : false;
    $reversed7    = ! empty( $settings['reversed7'] ) ? $settings['reversed7'] : false;
    $reversed10    = ! empty( $settings['reversed10'] ) ? $settings['reversed10'] : false;
    $bodyscrolling    = ! empty( $settings['bodyscrolling'] ) ? $settings['bodyscrolling'] : false;

    $this->set_attribute( '_root', 'class', 'bc-core-burguer' );
    $this->set_attribute( 'inner', 'data-scroll', $bodyscrolling );
    $output = "<div {$this->render_attributes( '_root' )}>";

    if ( $type ) {
        if ($type === 'style1') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style1' );
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <svg viewBox='0 0 100 100'>
                <path class='bc-burguer-style1__line--line1' d='M 20,29.000046 H 80.000231 C 80.000231,29.000046 94.498839,28.817352 94.532987,66.711331 94.543142,77.980673 90.966081,81.670246 85.259173,81.668997 79.552261,81.667751 75.000211,74.999942 75.000211,74.999942 L 25.000021,25.000058' />
                <path shape-rendering='optimizeSpeed' class='bc-burguer-style1__line--line2' d='M 20,50 H 80'/>
                <path class='bc-burguer-style1__line--line3' d='M 20,70.999954 H 80.000231 C 80.000231,70.999954 94.498839,71.182648 94.532987,33.288669 94.543142,22.019327 90.966081,18.329754 85.259173,18.331003 79.552261,18.332249 75.000211,25.000058 75.000211,25.000058 L 25.000021,74.999942' />
                </svg>
            </button>";
        }
        else if ($type === 'style2') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style2' );
            if($reversed2){$this->set_attribute( 'inner', 'class', 'bc-burguer-style2--reversed' );}
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <div class='bc-burguer-style2__wrapper'>
                    <div class='bc-burguer-style2__line--half-first'></div>
                    <div class='bc-burguer-style2__line'></div>
                    <div class='bc-burguer-style2__line--half-last'></div>
                </div>
            </button>
            ";
        }
        else if ($type === 'style3') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style3' );
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <span class='bc-burguer-style3__line'></span>
                <span class='bc-burguer-style3__line'></span>
            </button>
            ";
        }
        else if ($type === 'style4') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style4' );
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <span class='bc-burguer-style4__line'></span>
            </button>
            ";
        }
        else if ($type === 'style5') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style5' );
            if($reversed5){$this->set_attribute( 'inner', 'class', 'bc-burguer-style5--reversed' );}
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <span class='bc-burguer-style5__line'></span>
            </button>
            ";
        }
        else if ($type === 'style6') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style6' );
            if($reversed6){$this->set_attribute( 'inner', 'class', 'bc-burguer-style6--reversed' );}
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <span class='bc-burguer-style6__icon'></span>
            </button>
            ";
        }
        else if ($type === 'style7') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style7' );
            if($reversed7){$this->set_attribute( 'inner', 'class', 'bc-burguer-style7--reversed' );}
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <span class='bc-burguer-style7__line'></span>
            </button>
            ";
        }
        else if ($type === 'style8') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style8' );
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <span class='bc-burguer-style8__left-icon'></span>
                <span class='bc-burguer-style8__right-icon'></span>
            </button>
            ";
        }
        else if ($type === 'style9') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style9' );
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <span class='bc-burguer-style9__line'></span>
            </button>
            ";
        }
        else if ($type === 'style10') {
            $this->set_attribute( 'inner', 'class', 'bc-burguer-style10' );
            if($reversed10){$this->set_attribute( 'inner', 'class', 'bc-burguer-style10--reversed' );}
            $output .= "
            <button {$this->render_attributes( 'inner' )}>
                <div class='bc-burguer-style10__first-line'></div>
                <div class='bc-burguer-style10__second-line'></div>
            </button>
            ";
        }

        $output .= '</div>';
    }

	echo $output;
  }
}



