<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class B_Cursor extends \Bricks\Element {
  public $category     = 'Brickscore - Core';
  public $name         = 'Cursor';
  public $icon         = 'fa-regular fa-circle';
  public $css_selector = '';


  public function get_label() {
    return esc_html__( 'Cursor', 'bricks' );
  }

  public function set_control_groups() {
    $this->control_groups['magneticgroup'] = [
      'title' => esc_html__( 'Magnetic', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['repelgroup'] = [
      'title' => esc_html__( 'Repel', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['skewgroup'] = [
      'title' => esc_html__( 'Skew', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['stickgroup'] = [
      'title' => esc_html__( 'Stick', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['sizegroup'] = [
      'title' => esc_html__( 'Size', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['bordergroup'] = [
      'title' => esc_html__( 'Border', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['colorgroup'] = [
      'title' => esc_html__( 'Color', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['exclusiongroup'] = [
      'title' => esc_html__( 'Exclusion', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['textgroup'] = [
      'title' => esc_html__( 'Text', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['backdropgroup'] = [
      'title' => esc_html__( 'Backdrop', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['blurgroup'] = [
      'title' => esc_html__( 'Blur', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['opacitygroup'] = [
      'title' => esc_html__( 'Opacity', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['imagegroup'] = [
      'title' => esc_html__( 'Image/Video', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['hiddengroup'] = [
      'title' => esc_html__( 'Hidden', 'bricks' ),
      'tab'   => 'content',
    ];
    $this->control_groups['zindexgroup'] = [
      'title' => esc_html__( 'zIndex', 'bricks' ),
      'tab'   => 'content',
    ];
  }

  public function set_controls() {
    $this->controls['note'] = [
      'tab' => 'content',
      'description' => sprintf(html_entity_decode(esc_html__( 'NOTE: <br>Cursor can only be visible on the front.', 'bricks' )))
    ];

    $this->controls['defaultcursor'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Cursor', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => 'default',
    ];
    $this->controls['defaultcolor'] = [
      'tab' => 'content',
      'label' => esc_html__( 'Color', 'bricks' ),
      'type' => 'color',
      'inline' => true,
    ];
    $this->controls['defaultsize'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Size', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => 'scale(0.2)',
    ];
    $this->controls['defaultactive'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Active', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => 'scale(0.5)',
    ];
    $this->controls['defaultspeed'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Speed', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => '0.55',
    ];
    $this->controls['defaultease'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'GSAP easing', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => 'expo.out',
    ];
    $this->controls['defaultskew'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Skew', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => '0',
    ];
    $this->controls['defaultzindex'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'zIndex', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => '99999',
    ];
    $this->controls['defaultvisible'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Visible', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => 'true',
    ];
    $this->controls['defaulthide'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Hide on leave', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => 'true',
    ];
    $this->controls['magnetic'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'magneticgroup',
      'label'         => esc_html__( 'Magnetic elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Magnetic element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
      ],
    ];
    $this->controls['repel'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'repelgroup',
      'label'         => esc_html__( 'Repel elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Repel element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
      ],
    ];
    $this->controls['hidden'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'hiddengroup',
      'label'         => esc_html__( 'Hidden elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Hidden element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
      ],
    ];
    $this->controls['exclusion'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'exclusiongroup',
      'label'         => esc_html__( 'Exclusion elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Exclusion element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
      ],
    ];
    $this->controls['backdrop'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'backdropgroup',
      'label'         => esc_html__( 'Backdrop elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Backdrop element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'backdrop'       => [
          'label' => esc_html__( 'Backdrop', 'bricks' ),
          'type' => 'text',
          'placeholder' => '0px',
        ],
      ],
    ];
    $this->controls['blur'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'blurgroup',
      'label'         => esc_html__( 'Blur elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Blur element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'blur'       => [
          'label' => esc_html__( 'Blur', 'bricks' ),
          'type' => 'text',
          'placeholder' => '0px',
        ],
      ],
    ];
    $this->controls['skew'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'skewgroup',
      'label'         => esc_html__( 'Skew elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Skew element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'skew'       => [
          'label' => esc_html__( 'Skew', 'bricks' ),
          'type' => 'text',
        ],
      ],
    ];
    $this->controls['color'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'colorgroup',
      'label'         => esc_html__( 'Color elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Color element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'color'       => [
          'type'    => 'color',
          'label'   => esc_html__( 'Color', 'bricks' ),
        ],
      ],
    ];
    $this->controls['border'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'bordergroup',
      'label'         => esc_html__( 'Border elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Border element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'border'       => [
          'type'    => 'border',
          'label'   => esc_html__( 'Border', 'bricks' ),
        ],
      ],
    ];
    $this->controls['size'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'sizegroup',
      'label'         => esc_html__( 'Size elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Size element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'size'       => [
          'label' => esc_html__( 'Size', 'bricks' ),
          'type' => 'text',
          'placeholder' => 'scale(0.2)',
        ],
      ],
    ];
    $this->controls['fontfamily'] = [
      'tab'           => 'content',
      'group'			=> 'textgroup',
      'type' => 'typography',
      'exclude' => [
       'text-align',
       'text-shadow',
       'font-weight',
       'font-style',
       'text-align',
       'text-transform',
       'text-decoration',
       'font-size',
       'line-height',
       'letter-spacing',
       'color',
       'text-shadow',
      ],
      'popup' => false,
    ];
    $this->controls['fontcolor'] = [
      'tab' => 'content',
      'group'			=> 'textgroup',
      'label' => esc_html__( 'Color', 'bricks' ),
      'type' => 'color',
      'inline' => true,
    ];
    $this->controls['fontsize'] = [
      'tab'           => 'content',
      'group'			=> 'textgroup',
      'type' => 'typography',
      'exclude' => [
       'text-align',
       'text-shadow',
       'font-weight',
       'font-style',
       'text-align',
       'text-transform',
       'text-decoration',
       'font-family',
       'line-height',
       'letter-spacing',
       'color',
       'text-shadow',
      ],
      'popup' => false,
    ];
    $this->controls['texto'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'textgroup',
      'label'         => esc_html__( 'Text elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Text element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'texto'       => [
          'type' => 'text',
          'label' => esc_html__( 'Text', 'bricks' ),
        ],
      ],
    ];
    $this->controls['image'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'imagegroup',
      'label'         => esc_html__( 'Image/Video elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Image/Video element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'image'       => [
          'type'    => 'link',
          'label'   => esc_html__( 'Image/Video', 'bricks' ),
          'exclude'     => [
            'lightboxVideo',
            'lightboxImage',
            'media',
            'internal',
            'meta',
            'ariaLabel',
            'rel',
            'title',
            'newTab',
          ],
        ],
      ],
    ];
    $this->controls['stickdelta'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'group'			=> 'stickgroup',
      'label' => esc_html__( 'Stick delta', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => '0.15',
    ];
    $this->controls['stick'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'stickgroup',
      'label'         => esc_html__( 'Sticky elements', 'bricks' ),
      'placeholder'   => esc_html__( 'Sticky element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'fromclass'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Stick from element class', 'bricks' ),
        ],
        'toclass'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Stick to element class', 'bricks' ),
        ],
      ],
    ];
    $this->controls['zindex'] = [
      'tab'           => 'content',
      'type'          => 'repeater',
      'group'			=> 'zindexgroup',
      'label'         => esc_html__( 'zIndex elements', 'bricks' ),
      'placeholder'   => esc_html__( 'zIndex element', 'bricks' ),
      'titleProperty' => 'title',
      'fields'        => [
        'class'       => [
          'type'    => 'text',
          'label'   => esc_html__( 'Element class', 'bricks' ),
        ],
        'zindex'       => [
          'label' => esc_html__( 'zIndex', 'bricks' ),
          'type' => 'text',
        ],
      ],
    ];
  }

  


  public function enqueue_scripts() {
    wp_enqueue_script( 'bc-cursor', plugin_dir_url( __FILE__ ) . 'js/bc_cursor.min.js', array('bricks-scripts'), get_option('brickscore_element_version'), false);

    wp_enqueue_style( 'cursor-css-stylesheet', plugin_dir_url( __FILE__ ) . '../local_assets/cursor.min.css', array(), get_option('brickscore_element_version'), false );

    wp_enqueue_script( 'mouse-follower-js', plugin_dir_url( __FILE__ ) . '../local_assets/bc_mouse_follower.min.js', array('bricks-scripts'), get_option('brickscore_element_version'), false);
}


  public function render() {
    $settings = $this->settings;


    if ( isset($settings['defaultcolor']) && is_array($settings['defaultcolor']) && count($settings['defaultcolor']) > 0 ) {
      if (isset($settings['defaultcolor']['rgb'])) {
        $defaultcolor = $settings['defaultcolor']['rgb'];
      } else if(isset($settings['defaultcolor']['raw'])){
        $defaultcolor = $settings['defaultcolor']['raw'];
      }else {
        $defaultcolor = $settings['defaultcolor']['hex'];
      }
    }else{
      $defaultcolor = 'black';
    }


    $fontfamilys = !empty($settings['fontfamily']) ? $settings['fontfamily'] : false;
    $fontcolor = !empty($settings['fontcolor']) ? $settings['fontcolor'] : 'black';
    $fontsize = !empty($settings['fontsize']) ? $settings['fontsize'] : false;
    $defaultcursor = !empty($settings['defaultcursor']) ? $settings['defaultcursor'] : false;
    $defaultsize = !empty($settings['defaultsize']) ? $settings['defaultsize'] : 'scale(0.2)';
    $defaultactive = !empty($settings['defaultactive']) ? $settings['defaultactive'] : 'scale(0.5)';
    $defaultvisible = !empty($settings['defaultvisible']) ? $settings['defaultvisible'] : true;
    $defaultspeed = !empty($settings['defaultspeed']) ? $settings['defaultspeed'] : 0.55;
    $defaultskew = !empty($settings['defaultskew']) ? $settings['defaultskew'] : 0;
    $defaultease = !empty($settings['defaultease']) ? $settings['defaultease'] : 'expo.out';
    $defaultzindex = !empty($settings['defaultzindex']) ? $settings['defaultzindex'] : 99999;
    $defaulthide = !empty($settings['defaulthide']) ? $settings['defaulthide'] : true;
    $magnetics = ! empty( $settings['magnetic'] ) ? $settings['magnetic'] : false;
    $repels = ! empty( $settings['repel'] ) ? $settings['repel'] : false;
    $hiddens = ! empty( $settings['hidden'] ) ? $settings['hidden'] : false;
    $exclusions = ! empty( $settings['exclusion'] ) ? $settings['exclusion'] : false;
    $colors = ! empty( $settings['color'] ) ? $settings['color'] : false;
    $backdrops = ! empty( $settings['backdrop'] ) ? $settings['backdrop'] : false;
    $blurs = ! empty( $settings['blur'] ) ? $settings['blur'] : false;
    $skews = ! empty( $settings['skew'] ) ? $settings['skew'] : false;
    $borders = isset( $settings['border'] ) ? $settings['border'] : false;
    $sizes = ! empty( $settings['size'] ) ? $settings['size'] : false;
    $texts = ! empty( $settings['texto'] ) ? $settings['texto'] : false;
    $images = ! empty( $settings['image'] ) ? $settings['image'] : false;
    $stickdelta = !empty($settings['stickdelta']) ? $settings['stickdelta'] : 0.15;
    $sticks = ! empty( $settings['stick'] ) ? $settings['stick'] : false;


    if ($backdrops) {
      echo '<div class="bc-cursor__list-backdrops" data-clases="';
      foreach ( $backdrops as $backdrop ) {
        echo $backdrop['class'] . ' ';
      }
      echo '" data-backdrops="';
      foreach ( $backdrops as $backdrop ) {
        if ( isset($backdrop['backdrop']) ) {
          echo $backdrop['backdrop'] . ' ';
        }
        else{
          echo 'unset' . ' ';
        }
      }
      echo '"></div>';
    }
    if ($blurs) {
      echo '<div class="bc-cursor__list-blurs" data-clases="';
      foreach ( $blurs as $blur ) {
        echo $blur['class'] . ' ';
      }
      echo '" data-blurs="';
      foreach ( $blurs as $blur ) {
        if ( isset($blur['blur']) ) {
          echo $blur['blur'] . ' ';
        }
        else{
          echo 'unset' . ' ';
        }
      }
      echo '"></div>';
    }
    if ($images) {
      echo '<div class="bc-cursor__list-images" data-clases="';
      foreach ( $images as $image ) {
        echo $image['class'] . ' ';
      }
      echo '" data-images="';
      foreach ( $images as $image ) {
        if ( isset($image['image'])) {
          $last_image = $image['image']['url'];
          echo $last_image . 'd110777';
        }
        else{
          echo 'unset' . ' ';
        }
      }
      echo '"></div>';
    }
    if ($magnetics) {
      echo '<div class="bc-cursor__list-magnetics" data-clases="';
      foreach ( $magnetics as $magnetic ) {
        echo $magnetic['class'] . ' ';
      }
      echo '"></div>';
    }
    if ($repels) {
      echo '<div class="bc-cursor__list-repels" data-clases="';
      foreach ( $repels as $repel ) {
        echo $repel['class'] . ' ';
      }
      echo '"></div>';
    }
    if ($sticks) {
      echo '<div class="bc-cursor__list-sticks" data-fromclases="';
      foreach ( $sticks as $stick ) {
        echo $stick['fromclass'] . ' ';
      }
      echo '" data-toclases="';
      foreach ( $sticks as $stick ) {
        echo $stick['toclass'] . ' ';
      }
      echo '"></div>';
    }
    if ($hiddens) {
      echo '<div class="bc-cursor__list-hiddens" data-clases="';
      foreach ( $hiddens as $hidden ) {
        echo $hidden['class'] . ' ';
      }
      echo '"></div>';
    }
    if ($exclusions) {
      echo '<div class="bc-cursor__list-exclusions" data-clases="';
      foreach ( $exclusions as $exclusion ) {
        echo $exclusion['class'] . ' ';
      }
      echo '"></div>';
    }
    if ($colors) {
      echo '<div class="bc-cursor__list-colors" data-clases="';
      foreach ( $colors as $color ) {
        echo $color['class'] . ' ';
      }
      echo '" data-colors="';
      foreach ( $colors as $color ) {
        if ( isset($color['color']) && is_array($color['color']) && count($color['color']) > 0 ) {

        if (isset($color['color']['rgb'])) {
          $color_string = $color['color']['rgb'];
        } else if(isset($color['color']['raw'])){
          $color_string = $color['color']['raw'];
        }else {
          $color_string = $color['color']['hex'];
        }

          echo $color_string . 'd110777';
        }
        else{
          echo 'unset' . ' ';
        }
      }
      echo '"></div>';
    }
    if ($borders) {
      echo '<div class="bc-cursor__list-borders" data-clases="';
      foreach ( $borders as $border ) {
        echo $border['class'] . ' ';
      }
      echo '" data-borders="';
      foreach ( $borders as $border ) {
        if ( isset($border['border']) ) {
          /*border width*/
          if ( isset($border['border']['width']['top']) ){
            echo $border['border']['width']['top'] . ' ';
          }else{echo '0' . ' ';}
          if ( isset($border['border']['width']['right']) ){
            echo $border['border']['width']['right'] . ' ';
          }else{echo '0' . ' ';}
          if ( isset($border['border']['width']['bottom']) ){
            echo $border['border']['width']['bottom'] . ' ';
          }else{echo '0' . ' ';}
          if ( isset($border['border']['width']['left']) ){
            echo $border['border']['width']['left'] . ' ';
          }else{echo '0' . ' ';}

          /*style*/
          if ( isset($border['border']['style']) ){
            echo $border['border']['style'] . ' ';
          }else{echo 'unset' . ' ';}

          /*color*/
          if (isset($border['border']['color']['rgb'])) {
            $color_string = $border['border']['color']['rgb'];
          }else if(isset($border['border']['color']['raw'])){
            $color_string = $border['border']['color']['raw'];
          }else if(isset($border['border']['color']['hex'])){
            $color_string = $border['border']['color']['hex'];
          }else{
            $color_string = 'unset';
          }
          echo $color_string . ' ';

          /*border radius*/
          if ( isset($border['border']['radius']['top']) ){
            echo $border['border']['radius']['top'] . ' ';
          }else{echo '0' . ' ';}
          if ( isset($border['border']['radius']['right']) ){
            echo $border['border']['radius']['right'] . ' ';
          }else{echo '0' . ' ';}
          if ( isset($border['border']['radius']['bottom']) ){
            echo $border['border']['radius']['bottom'] . ' ';
          }else{echo '0' . ' ';}
          if ( isset($border['border']['radius']['left']) ){
            echo $border['border']['radius']['left'] . ' ';
          }else{echo '0' . ' ';}

          /*separación entre cada ajuste de border*/
          echo 'd110777' . ' ';
        }
        else{
          echo 'd110777' . ' ';
        }
      }
      echo '"></div>';
    }
    if ($skews) {
      echo '<div class="bc-cursor__list-skews" data-clases="';
      foreach ( $skews as $skew ) {
        echo $skew['class'] . ' ';
      }
      echo '" data-skews="';
      foreach ( $skews as $skew ) {
        if ( isset($skew['skew']) ) {
          echo $skew['skew'] . ' ';
        }
        else{
          echo 'unset' . ' ';
        }
      }
      echo '"></div>';
    }
    if ($sizes) {
      echo '<div class="bc-cursor__list-sizes" data-clases="';
      foreach ( $sizes as $size ) {
        echo $size['class'] . ' ';
      }
      echo '" data-sizes="';
      foreach ( $sizes as $size ) {
        if ( isset($size['size']) ) {
          echo $size['size'] . ' ';
        }
        else{
          echo 'unset' . ' ';
        }
      }
      echo '"></div>';
    }
    if ($texts) {
      echo '<div class="bc-cursor__list-texts" data-clases="';
      foreach ( $texts as $texto ) {
        echo $texto['class'] . ' ';
      }
      echo '" data-texts="';
      foreach ( $texts as $texto ) {
        if (isset($texto['texto'])) {
            echo $texto['texto'] . 'd110777';
        }
      }
      echo '" data-fontfamily="';
      if (isset($fontfamilys)) {
        print_r($fontfamilys);
      }
      echo '" data-fontcolor="';
      if (isset($fontcolor)) {
        if (isset($fontcolor['rgb'])) {
          $fontcolor = $fontcolor['rgb'];
        }else if(isset($fontcolor['raw'])){
          $fontcolor = $fontcolor['raw'];
        }else {
          $fontcolor = $fontcolor['hex'];
        }

        echo $fontcolor;
      }



      echo '" data-fontsize="';
      if (isset($fontsize)) {
        print_r($fontsize);
      }
      echo '"></div>';
    }

    $this->set_attribute( 'inner', 'class', 'bc-cursor' );
    $this->set_attribute( 'inner', 'data-defaultcursor', "$defaultcursor");
    $this->set_attribute( 'inner', 'data-defaultcolor', "$defaultcolor");
    $this->set_attribute( 'inner', 'data-defaultsize', "$defaultsize");
    $this->set_attribute( 'inner', 'data-defaultactive', "$defaultactive");
    $this->set_attribute( 'inner', 'data-defaultvisible', "$defaultvisible");
    $this->set_attribute( 'inner', 'data-defaultspeed', "$defaultspeed");
    $this->set_attribute( 'inner', 'data-defaultskew', "$defaultskew");
    $this->set_attribute( 'inner', 'data-defaultease', "$defaultease");
    $this->set_attribute( 'inner', 'data-defaultzindex', "$defaultzindex");
    $this->set_attribute( 'inner', 'data-defaulthide', "$defaulthide");
    $this->set_attribute( 'inner', 'data-stickdelta', "$stickdelta");

    $output = "<div {$this->render_attributes( 'inner' )} >";

    $output .= '</div>';

		echo $output;
  }
}
