<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class Bc_Morphing_Menu_Item extends \Bricks\Element {
  public $name         = 'morphingmenuitem';
  public $icon         = 'ti-link';

  public function get_label() {
    return esc_html__( 'Morphing Item', 'bricks' );
  }

  public function set_control_groups() {

  }

  public function set_controls() {
    $this->controls['inner_title'] = [
        'tab'            => 'content',
        'type'           => 'text',
        'hasDynamicData' => 'text',
        'default'        => esc_html__( 'Menu item', 'bricks' ),
        'placeholder'    => esc_html__( 'Title goes here ..', 'bricks' ),
    ];
    $this->controls['link'] = [
        'tab'   => 'content',
        'label' => esc_html__( 'Link to', 'bricks' ),
        'type'  => 'link',
    ];
  }

    
  public function render() {
    $settings = $this->settings;
    $inner_title    = ! empty( $settings['inner_title'] ) ? $settings['inner_title'] : 'Brickscore';

    if ( ! empty( $settings['link'] ) ) {
        $this->set_link_attributes( '_root', $settings['link'] );
    }

    $this->set_attribute( '_root', 'class', 'bc-morphing-menu__item' );
    $this->set_attribute( '_root', 'data-morph-bg', 'morph-bg-1' );
    $this->set_attribute( '_root', 'tabindex', '0' );

    $output = "<a {$this->render_attributes( '_root' )}>$inner_title
        <span class='demo-morph-bg-target' data-morph-bg-target aria-hidden='true'></span>
    ";
    $output .= '</a>';

	echo $output;
  }
}