<?php
namespace Bricks;
if ( ! defined( 'ABSPATH' ) ) exit;

class B_ScribbleTitle extends \Bricks\Element {
  public $category     = 'Brickscore - Titles';
  public $name         = 'scribble-title';
  public $icon         = 'ti-text';
  public $tag      = 'h3';
  public $css_selector = '';
  public $nestable     = true;

  public function get_label() {
    return esc_html__( 'Scribble Reveal', 'bricks' );
  }

  public function set_control_groups() {

  }

  public function set_controls() {
    $this->controls['tag'] = [
        'tab'         => 'content',
        'label'       => esc_html__( 'HTML tag', 'bricks' ),
        'type'        => 'select',
        'options'     => [
            'h1' => 'h1',
            'h2' => 'h2',
            'h3' => 'h3',
            'h4' => 'h4',
            'h5' => 'h5',
            'h6' => 'h6',
            'p' => 'p',
            'span' => 'span',
        ],
        'clearable'   => false,
        'inline'      => true,
        'placeholder' => 'h3',
        'default'     => 'h3',
    ];
  }

  public function get_nestable_children() {
    return [
        [
            'name'     => 'heading',
            'label'    => esc_html__( 'Title', 'bricks' ),
            'settings' => [
              'text' => esc_html__( 'Scribble Reveal&nbsp;', 'bricks' ),
              'tag'  => 'span',
              '_hidden'         => [
                              '_cssClasses' => 'bc-scribble-title__heading',
                ],
            ],
        ],

        [
            'name'     => 'scribblechild',
        ],
    ];
  }

  public function render() {
    $settings = $this->settings;

    $this->set_attribute( '_root', 'class', 'bc-scribble-title' );
    $this->set_attribute( 'inner_title', 'class', 'bc-scribble-title__element' );

    $output = "<div {$this->render_attributes( '_root' )}>";
    $output .= "<{$this->tag} {$this->render_attributes( 'inner_title' )}>";
    $output .= \Bricks\Frontend::render_children( $this );
    $output .= "</{$this->tag}>";
    $output .= '</div>';

	echo $output;
  }
}

