<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class B_Smoothscroll extends \Bricks\Element {
  public $category     = 'Brickscore - Core';
  public $name         = 'smoothscroll';
  public $icon         = 'fa-solid fa-bacon';
  public $scripts      = ['smoothscroll'];

  public function get_label() {
    return esc_html__( 'Smooth Scroll', 'bricks' );
  }

  public function set_control_groups() {

  }

  public function set_controls() {
    $this->controls['wrapper'] = [
      'hasDynamicData' => false,
      'tab' => 'content',
      'label' => esc_html__( 'Wrapper', 'bricks' ),
      'type' => 'text',
      'inline' => true,
      'placeholder' => 'body',
  ];
    $this->controls['duration'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Duration', 'bricks' ),
        'type' => 'text',
        'inline' => true,
        'placeholder' => '1.8',
    ];
    $this->controls['wheelmultiplier'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Wheel multiplier', 'bricks' ),
        'type' => 'text',
        'inline' => true,
        'placeholder' => '1',
    ];
    $this->controls['smoothtouch'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Smooth touch events', 'bricks' ),
        'type' => 'checkbox',
        'inline' => true,
        'small' => true,
        'default' => false,
    ];
    $this->controls['touchmultiplier'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Touch multiplier', 'bricks' ),
        'type' => 'text',
        'inline' => true,
        'placeholder' => '2',
    ];
    $this->controls['infinite'] = [
        'hasDynamicData' => false,
        'tab' => 'content',
        'label' => esc_html__( 'Infinite scroll', 'bricks' ),
        'type' => 'checkbox',
        'inline' => true,
        'small' => true,
        'default' => false,
    ];
  }


  public function enqueue_scripts() {
    wp_enqueue_script( 'lenis-js', plugin_dir_url( __FILE__ ) . '../local_assets/bc_lenis.min.js', array(), get_option('brickscore_element_version'), false);
    
    wp_enqueue_script( 'smooth_scroll', plugin_dir_url( __FILE__ ) . 'js/bc_smooth_scroll.min.js', array('bricks-scripts'),  get_option('brickscore_element_version'), false);
  }

  public function render() {
    $settings = $this->settings;
    $duration = ! empty( $settings['duration'] ) ? $settings['duration'] : 1.8;
    $smoothtouch = ! empty( $settings['smoothtouch'] ) ? $settings['smoothtouch'] : false;
    $wheelmultiplier = ! empty( $settings['wheelmultiplier'] ) ? $settings['wheelmultiplier'] : 1;
    $touchmultiplier = ! empty( $settings['touchmultiplier'] ) ? $settings['touchmultiplier'] : 1;
    $infinite = ! empty( $settings['infinite'] ) ? $settings['infinite'] : false;
    $wrapper = ! empty( $settings['wrapper'] ) ? $settings['wrapper'] : 'body';

    $this->set_attribute( '_root', 'data-duration', "$duration");
    $this->set_attribute( '_root', 'data-smoothtouch', "$smoothtouch");
    $this->set_attribute( '_root', 'data-wheelmultiplier', "$wheelmultiplier");
    $this->set_attribute( '_root', 'data-touchmultiplier', "$touchmultiplier");
    $this->set_attribute( '_root', 'data-infinite', "$infinite");
    $this->set_attribute( '_root', 'data-wrapper', "$wrapper");


    $this->set_attribute( '_root', 'class', 'bc-smooth-scroll-data' );

    $output = "<div {$this->render_attributes( '_root' )}>";

    $output .= '</div>';

	echo $output;
  }
}



