<?php
namespace Bricks;
if ( ! defined( 'ABSPATH' ) ) exit;

class B_Title_Images extends Element {
  public $category     = 'Brickscore - Titles';
  public $name         = 'title-images';
  public $icon         = 'fa-solid fa-images';
  public $tag      = 'h3';
  public $scripts      = ['titleimages'];
  public $nestable     = true;

  public function get_label() {
    return esc_html__( 'Inline Images', 'bricks' );
  }

  public function set_control_groups() {

  }

  public function set_controls() {

  }

  public function get_nestable_item() {
		return [
			'name'     => 'block',
			'label'    => esc_html__( 'Line wrapper', 'bricks' ),
      'settings' => [
        '_hidden' => [
          '_cssClasses' => 'bc-inline-div',
        ],
      ],
			'children' => [
        [
          'name'     => 'heading',
          'label'    => esc_html__( 'Title', 'bricks' ),
          'settings' => [
            'text' => esc_html__( 'Bricks', 'bricks' ),
            'tag'  => 'span',
            '_hidden'         => [
							'_cssClasses' => 'bc-inline-span',
						],
          ],
				],
				[
					'name'     => 'image',
					'label'    => esc_html__( 'Image', 'bricks' ),
					'settings' => [
						'_hidden'         => [
							'_cssClasses' => 'bc-inline-img',
						],
					],
				],
			],
		];
}

public function get_nestable_children() {
    $item = $this->get_nestable_item();
    return [$item];
}


public function enqueue_scripts() {
  wp_enqueue_script( 'titleimages', plugin_dir_url( __FILE__ ) . 'js/bc_title_images.min.js', array('bricks-scripts'), get_option('brickscore_element_version'), false);
}

  public function render() {
    $settings = $this->settings;


    $this->set_attribute( '_root', 'class', 'bc-title-images' );

    $output = "<div {$this->render_attributes( '_root' )}>";

    $output .= "<div class='bc-title-images__wrapper'>";
    $output .= "<div>";
    $output .= Frontend::render_children( $this );
    $output .= "</div>";
    $output .= '</div>';

    $output .= '</div>';

	echo $output;
  }
}

