<?php

namespace Brickscore;

if ( ! defined( 'ABSPATH' ) ) exit;

class BC_Animator {
    public function init() {

        add_action('wp_footer', array($this, 'generate_input'), PHP_INT_MAX);

        wp_enqueue_script( 'bc-jquery', plugin_dir_url( __FILE__ ) . '../local_assets/bc_jquery.min.js', array(), get_option('brickscore_element_version'), false); //Load jQuery - TEST AJAX

        wp_enqueue_script( 'popper-js', plugin_dir_url( __FILE__ ) . '../local_assets/tippy/bc_popper.min.js', array(), get_option('brickscore_element_version'), false); //Tippy
        wp_enqueue_script( 'tippy-js', plugin_dir_url( __FILE__ ) . '../local_assets/tippy/bc_tippy.min.js', array(), get_option('brickscore_element_version'), false); //Tippy
        wp_enqueue_style( 'tippy-scale-css', plugin_dir_url( __FILE__ ) . '../local_assets/tippy/bc_scale.min.css', array(), get_option('brickscore_element_version'), false); //Tippy

        wp_enqueue_style( 'bc-core-animator', plugin_dir_url( __FILE__ ) . 'bc_animator.css', array(), get_option('brickscore_element_version'), false); //Load Animator styling

        $bc_brickscore_animator_theme_enable = get_option('bc_brickscore_animator_theme_enable', 'true');
        if ($bc_brickscore_animator_theme_enable === 'true') {
            wp_enqueue_style( 'bc-core-animator-brickscore-theme', plugin_dir_url( __FILE__ ) . 'bc_animator_brickscore_theme.css', array(), get_option('brickscore_element_version'), 'all'); //Load Theme
        }else if ($bc_brickscore_animator_theme_enable === 'dark') {
            wp_enqueue_style( 'bc-core-animator-bricksdark-theme', plugin_dir_url( __FILE__ ) . 'bc_animator_bricksdark_theme.css', array(), get_option('brickscore_element_version'), 'all'); //Load Theme
        }else if ($bc_brickscore_animator_theme_enable === 'light') {
            wp_enqueue_style( 'bc-core-animator-brickslight-theme', plugin_dir_url( __FILE__ ) . 'bc_animator_brickslight_theme.css', array(), get_option('brickscore_element_version'), 'all'); //Load Theme
        }else{
            wp_enqueue_style( 'bc-core-animator-brickscore-theme', plugin_dir_url( __FILE__ ) . 'bc_animator_brickscore_theme.css', array(), get_option('brickscore_element_version'), 'all'); //Load Theme
        }
        
        wp_enqueue_script( 'bc-animator', plugin_dir_url( __FILE__ ) . 'bc_animator.js', array('bricks-scripts'), get_option('brickscore_element_version'), false); //Load Animator JS     
        wp_enqueue_script( 'bc-animator-animations', plugin_dir_url( __FILE__ ) . 'bc_animator_animations.js', array('bricks-scripts'), get_option('brickscore_element_version'), false); //Load Animator animations JS   

        add_action('wp_enqueue_scripts', array($this, 'enviar_variable_a_js'));
        add_action('wp_ajax_actualizar_variable_php', array($this, 'actualizar_variable_php'));
        add_action('wp_ajax_nopriv_actualizar_variable_php', array($this, 'actualizar_variable_php'));
        add_action('wp_enqueue_scripts', array($this, 'enviar_variables_a_animations'));

    }

    function enviar_variable_a_js() {
        // Tu variable en PHP que deseas enviar a JavaScript
        $mi_variable = get_option('mi_variable', 0);
    
        // Enviar la variable a JavaScript
        wp_localize_script('bc-animator', 'datos_php', array(
            'mi_variable' => $mi_variable,
            'ajaxurl' => admin_url('admin-ajax.php'),
        ));
    }
    
    function actualizar_variable_php() {
        if (isset($_POST['mi_variable'])) {
            $mi_variable = $_POST['mi_variable']; // Recibimos la variable en formato Array desde JS

            $mi_variable_json = json_encode($mi_variable); // Pasamos el Array a formato JSON
            update_option('mi_variable', $mi_variable_json); // Se almacenan todos los datos en formato JSON
        }
        wp_die();
    }

    function enviar_variables_a_animations() {
        // Tu variable en PHP que deseas enviar a JavaScript
        $mi_variable = get_option('mi_variable', 0);
    
        // Enviar la variable a JavaScript
        wp_localize_script('bc-animator-animations', 'data_animator', array(
            'data_animations' => $mi_variable,
            'ajaxurl' => admin_url('admin-ajax.php'),
        ));
    }
 

    function generate_input() {

        //Load this HTML at builder (contemplates builder & iframe) & not iframe
        //Core Animator Builder
        if(bricks_is_builder_iframe()){ 

        $mi_variable_json = get_option('mi_variable');
        $mi_variable = json_decode($mi_variable_json, true);
            
        echo "
        <div class='bc-div-cursor-test'></div>
        <div class='bc-animator bc-animator--hide'>
        <div class='bc-animator__cols'>
            <div class='bc-animator__timelines-wrapper'>
                <div class='bc-animator__timelines'>
                    <div class='bc-animator__wrapper-title'>
                        <span class='bc-animator__timelines-title'>Timelines</span>
                    </div>
        ";

                    if (empty($mi_variable['timelines'])) {
                        // Imprimir el HTML predeterminado si $timelines está vacío
                        echo "
                            <div class='bc-animator__timeline-agroup bc-animator__timeline-input--active'>
                                <input class='bc-animator__timeline-input' type='text' autocomplete='off' value='timeline--1' spellcheck='false'>
                                <div class='bc-animator__timeline-removal'></div>
                            </div>
                        ";
                    } else {
                        $isFirst = true; // Variable de control para rastrear el primer elemento

                        foreach ($mi_variable['timelines'] as $timeline) {
                            $class = $isFirst ? 'bc-animator__timeline-input--active' : ''; // Agrega la clase solo al primer elemento
                            echo "
                                <div class='bc-animator__timeline-agroup $class'>
                                    <input class='bc-animator__timeline-input' type='text' autocomplete='off' value='$timeline' spellcheck='false'>
                                    <div class='bc-animator__timeline-removal'></div>
                                </div>
                            ";

                            $isFirst = false; // Marca que el primer elemento ya ha sido procesado
                        }
                    }

                    echo "
                        <div class='bc-animator__add-timeline-wrapper'>
                            <div class='bc-animator__add-timeline'></div>
                        </div>
                    </div>
                </div>
                ";

                if (empty($mi_variable['panels'])) {
                    // Imprimir el HTML predeterminado si $panels está vacío
                    echo "
                    <div class='bc-animator__inputs'>
                        <div class='bc-animator__col'>
                            <div class='bc-animator__wrapper-title'>
                                <span class='bc-animator__title'>ScrollTrigger</span>
                                <span class='bc-animator__tippy' id='bc-animator__tippy-properties'>i</span>
                            </div>
                            <div class='bc-animator__agroup'>
                                <span class='bc-animator__input-title'>Element</span>
                                <input class='bc-animator__input targetElement' type='text' autocomplete='off' spellcheck='false'>
                                <div  class='bc-animator__selector targetElementSelector'></div>
                            </div>
                            <div class='bc-animator__agroup'>
                                <span class='bc-animator__input-title'>Trigger</span>
                                <input class='bc-animator__input targetTrigger' type='text' autocomplete='off' placeholder='this' spellcheck='false'>
                                <div class='bc-animator__selector targetTriggerSelector'></div>
                            </div>
                            <div class='bc-animator__agroup bc-animator__agroup--wselector'>
                                <span class='bc-animator__input-title'>Start</span>
                                <input class='bc-animator__input' type='text' autocomplete='off' placeholder='top bottom' value='top bottom' spellcheck='false'>
        
                                <div class='bc-animator__select-options'></div>
                                <ul class='bc-animator__ul-select'>
                                    <li>top top</li>
                                    <li>top center</li>
                                    <li>top bottom</li>
                                    <li>top 25%</li>
                                    <li>top 50%</li>
                                    <li>top 75%</li>
                                    <li>top 100px</li>
                                    <li>center top</li>
                                    <li>center center</li>
                                    <li>center bottom</li>
                                    <li>center 25%</li>
                                    <li>center 50%</li>
                                    <li>center 75%</li>
                                    <li>center 100px</li>
                                    <li>bottom top</li>
                                    <li>bottom center</li>
                                    <li>bottom bottom</li>
                                    <li>bottom 25%</li>
                                    <li>bottom 50%</li>
                                    <li>bottom 75%</li>
                                    <li>bottom 100px</li>
                                </ul>
                            </div>
                        </div>
                        <div class='bc-animator__col'>
                            <div class='bc-animator__wrapper-title'>
                                <span class='bc-animator__title'>Animation</span>
                                <span class='bc-animator__tippy' id='bc-animator__tippy-animation'>i</span>
                            </div>
                            <div class='bc-animator__agroup bc-animator__agroup--wselector'>
                                <span class='bc-animator__input-title'>Property</span>
                                <input class='bc-animator__input' type='text' autocomplete='off' placeholder='opacity' value='opacity' spellcheck='false'>
        
                                <div class='bc-animator__select-options'></div>
                                <ul class='bc-animator__ul-select'>
                                    <li>opacity</li>
                                    <li>x</li>
                                    <li>y</li>
                                    <li>z</li>
                                    <li>scale</li>
                                    <li>width</li>
                                    <li>height</li>
                                    <li>top</li>
                                    <li>left</li>
                                    <li>right</li>
                                    <li>bottom</li>
                                    <li>color</li>
                                    <li>background</li>
                                </ul>
                            </div>
                            <div class='bc-animator__agroup'>
                                <span class='bc-animator__input-title'>From</span>
                                <input class='bc-animator__input' type='text' autocomplete='off' placeholder='0' value='0' spellcheck='false'>
                            </div>
                            <div class='bc-animator__agroup'>
                                <span class='bc-animator__input-title'>To</span>
                                <input class='bc-animator__input' type='text' autocomplete='off' placeholder='1' value='1' spellcheck='false'>
                            </div>
                            <div class='bc-animator__agroup'>
                                <span class='bc-animator__input-title'>Duration</span>
                                <input class='bc-animator__input bc-animator__input--duration' type='text' autocomplete='off' placeholder='1' value='1' spellcheck='false'>
                            </div>
                            <div class='bc-animator__agroup'>
                                <span class='bc-animator__input-title'>Delay</span>
                                <input class='bc-animator__input bc-animator__input--delay' type='text' autocomplete='off' placeholder='0' value='0' spellcheck='false'>
                            </div>
                            <div class='bc-animator__agroup bc-animator__agroup--wselector'>
                                <span class='bc-animator__input-title'>Ease</span>
                                <input class='bc-animator__input' type='text' autocomplete='off' placeholder='sine' value='sine' spellcheck='false'>
        
                                <div class='bc-animator__select-options'></div>
                                <ul class='bc-animator__ul-select'>
                                    <li>none</li>
                                    <li>power1</li>
                                    <li>power2</li>
                                    <li>power3</li>
                                    <li>power4</li>
                                    <li>back</li>
                                    <li>bounce</li>
                                    <li>circ</li>
                                    <li>elastic</li>
                                    <li>expo</li>
                                    <li>sine</li>
                                    <li>steps</li>
                                </ul>
                            </div>
                        </div>
                    </div>
                    ";
                } else {
                    $isFirst = true; // Variable de control para rastrear el primer elemento
                
                    foreach ($mi_variable['panels'] as $index => $panel) {
                        $element = $panel[0];
                        $trigger = $panel[1];
                        $start = $panel[2];
                        $property = $panel[3];
                        $from = $panel[4];
                        $to = $panel[5];
                        $duration = $panel[6];
                        $delay = $panel[7];
                        $ease = $panel[8];
                
                        $class = $isFirst ? '' : 'bc-animator__inputs--hide'; // Agrega la clase solo a los elementos que no son el primero
                
                        echo "
                        <div class='bc-animator__inputs $class'>
                            <div class='bc-animator__col'>
                                <div class='bc-animator__wrapper-title'>
                                    <span class='bc-animator__title'>ScrollTrigger</span>
                                    <span class='bc-animator__tippy' id='bc-animator__tippy-properties'>i</span>
                                </div>
                                <div class='bc-animator__agroup'>
                                    <span class='bc-animator__input-title'>Element</span>
                                    <input class='bc-animator__input targetElement' type='text' autocomplete='off' spellcheck='false' value='$element'>
                                    <div class='bc-animator__selector targetElementSelector'></div>
                                </div>
                                <div class='bc-animator__agroup'>
                                    <span class='bc-animator__input-title'>Trigger</span>
                                    <input class='bc-animator__input targetTrigger' type='text' autocomplete='off' placeholder='this' spellcheck='false' value='$trigger'>
                                    <div class='bc-animator__selector targetTriggerSelector'></div>
                                </div>
                                <div class='bc-animator__agroup bc-animator__agroup--wselector'>
                                    <span class='bc-animator__input-title'>Start</span>
                                    <input class='bc-animator__input' type='text' autocomplete='off' placeholder='top bottom' spellcheck='false' value='$start'>
            
                                    <div class='bc-animator__select-options'></div>
                                    <ul class='bc-animator__ul-select'>
                                        <li>top top</li>
                                        <li>top center</li>
                                        <li>top bottom</li>
                                        <li>top 25%</li>
                                        <li>top 50%</li>
                                        <li>top 75%</li>
                                        <li>top 100px</li>
                                        <li>center top</li>
                                        <li>center center</li>
                                        <li>center bottom</li>
                                        <li>center 25%</li>
                                        <li>center 50%</li>
                                        <li>center 75%</li>
                                        <li>center 100px</li>
                                        <li>bottom top</li>
                                        <li>bottom center</li>
                                        <li>bottom bottom</li>
                                        <li>bottom 25%</li>
                                        <li>bottom 50%</li>
                                        <li>bottom 75%</li>
                                        <li>bottom 100px</li>
                                    </ul>
                                </div>
                            </div>
                            <div class='bc-animator__col'>
                                <div class='bc-animator__wrapper-title'>
                                    <span class='bc-animator__title'>Animation</span>
                                    <span class='bc-animator__tippy' id='bc-animator__tippy-animation'>i</span>
                                </div>
                                <div class='bc-animator__agroup bc-animator__agroup--wselector'>
                                    <span class='bc-animator__input-title'>Property</span>
                                    <input class='bc-animator__input' type='text' autocomplete='off' placeholder='opacity' spellcheck='false' value='$property'>
            
                                    <div class='bc-animator__select-options'></div>
                                    <ul class='bc-animator__ul-select'>
                                        <li>opacity</li>
                                        <li>x</li>
                                        <li>y</li>
                                        <li>z</li>
                                        <li>scale</li>
                                        <li>width</li>
                                        <li>height</li>
                                        <li>top</li>
                                        <li>left</li>
                                        <li>right</li>
                                        <li>bottom</li>
                                        <li>color</li>
                                        <li>background</li>
                                    </ul>
                                </div>
                                <div class='bc-animator__agroup'>
                                    <span class='bc-animator__input-title'>From</span>
                                    <input class='bc-animator__input' type='text' autocomplete='off' placeholder='0' spellcheck='false' value='$from'>
                                </div>
                                <div class='bc-animator__agroup'>
                                    <span class='bc-animator__input-title'>To</span>
                                    <input class='bc-animator__input' type='text' autocomplete='off' placeholder='1' spellcheck='false' value='$to'>
                                </div>
                                <div class='bc-animator__agroup'>
                                    <span class='bc-animator__input-title'>Duration</span>
                                    <input class='bc-animator__input bc-animator__input--duration' type='text' autocomplete='off' placeholder='1' spellcheck='false' value='$duration'>
                                </div>
                                <div class='bc-animator__agroup'>
                                    <span class='bc-animator__input-title'>Delay</span>
                                    <input class='bc-animator__input bc-animator__input--delay' type='text' autocomplete='off' placeholder='0' spellcheck='false' value='$delay'>
                                </div>
                                <div class='bc-animator__agroup bc-animator__agroup--wselector'>
                                    <span class='bc-animator__input-title'>Ease</span>
                                    <input class='bc-animator__input' type='text' autocomplete='off' placeholder='sine' spellcheck='false' value='$ease'>
            
                                    <div class='bc-animator__select-options'></div>
                                    <ul class='bc-animator__ul-select'>
                                        <li>none</li>
                                        <li>power1</li>
                                        <li>power2</li>
                                        <li>power3</li>
                                        <li>power4</li>
                                        <li>back</li>
                                        <li>bounce</li>
                                        <li>circ</li>
                                        <li>elastic</li>
                                        <li>expo</li>
                                        <li>sine</li>
                                        <li>steps</li>
                                    </ul>
                                </div>
                            </div>
                        </div>
                        ";
                
                        $isFirst = false; // Marca que el primer elemento ya ha sido procesado
                    }
                }                

                echo "
            </div>
    
            <div class='bc-animator__bottom-wrapper'>
                <div class='bc-animator__save-play-wrapper'>
                    <div class='bc-animator__play-markers-wrapper'>
                        <div class='bc-animator__play-wrapper'>
                            <div class='bc-animator__play'></div>
                            <div class='bc-animator__time'>0.00</div>
                        </div>
                    ";

                    if (empty($mi_variable['markers'])) {
                        echo "
                        <div class='bc-animator__group-markers'>
                            <span class='bc-animator__checkboxes-title'>Markers</span>
                            <div class='bc-animator__checkbox-wrapper'>
                            <input class='bc-animator__checkbox' type='checkbox' id='bc-markers'/><label class='bc-animator__switch' for='bc-markers'>Toggle</label>
                            </div>
                        </div>
                        ";
                    }else{
                        $markers = $mi_variable['markers'];
                        $markers_checkbox = $markers == 'true' ? 'checked' : '';
                        echo "
                        <div class='bc-animator__group-markers'>
                            <span class='bc-animator__checkboxes-title'>Markers</span>
                            <div class='bc-animator__checkbox-wrapper'>
                                <input class='bc-animator__checkbox' type='checkbox' id='bc-markers' $markers_checkbox/><label class='bc-animator__switch' for='bc-markers'>Toggle</label>
                            </div>
                        </div>
                        ";
                    }

                    echo "
                    </div>
                    <div class='bc-animator__save'>
                        <span class='bc-animator__save-span'>Save</span>
                        <div class='bc-animator__save-icon'></div>
                    </div>
                </div>
                
                <div class='bc-animator__timeline-view-wrapper-wrapper'>
                    <div class='bc-animator__timeline-view-wrapper'>
                        <div class='bc-animator__timeline-line'></div>
                    </div>
                </div>
            </div>

            <div class='bc-animator__resizable'></div>
            <div class='bc-animator__draggable bc-animator__draggable--left'></div>
            <div class='bc-animator__draggable bc-animator__draggable--right'></div>
        </div>
                
        ";

        }

    }

}