<?php

namespace Brickscore;

class Initialize {
	public function __construct() {
        // Initialize the SureCart client
        if ( ! class_exists( 'SureCart\Licensing\Client' ) ) {
            require_once BRICKSCORE_PLUGIN_DIR . '/licensing/src/Client.php';
        }
        $client = new \SureCart\Licensing\Client(
            'brickscore',
            'pt_v7YkTVRoVwrLbHWKCb97fp2X',
            BRICKSCORE_FILE
        );
        
        // Add the license & front-end settings page.
        $client->settings()->add_page(
            [
            'type'                 => 'submenu',
            'parent_slug'          => 'brickscore',
            'page_title'           => 'Brickscore',
            'menu_title'           => 'Brickscore',
            'capability'           => 'manage_options',
            'menu_slug'            => $client->slug,
            'icon_url'             => '',
            'position'             => null,
            'parent_slug'          => 'bricks',
            ]
        );

        add_action('plugins_loaded', array($this, 'wp_load_brickscore'));
        add_filter('plugin_action_links_' . BRICKSCORE_FILE_NAME, array($this, 'brickscore_settings_link'));        
	}

    public static function wp_load_brickscore() {
        $activate_brickscore = get_option('activate_brickscore');
    
        if (($activate_brickscore == true && self::is_bricks_theme_active())) {
            require_once 'elements.php';
        }
    }
    
    // Brickscore settings link at plugins
    public static function brickscore_settings_link( $links ) {
        $links[] = '<a href="' . admin_url( 'admin.php?page=brickscore' ) . '">' . __('Settings') . '</a>';
        return $links;
    }
    
    // Check if Bricks parent theme or Bricks child theme are active
    public static function is_bricks_theme_active() {
        $theme = wp_get_theme();
        $theme_folder = basename($theme->get_stylesheet_directory());
        $parent_theme_folder = basename($theme->get_template_directory());
    
        if ($theme_folder === 'bricks' || $parent_theme_folder === 'bricks' || strpos($theme_folder, 'brick') !== false || strpos($parent_theme_folder, 'brick') !== false) {
            return true;
        }
        return false;
    }
}